/***************************************************************************
 *   Copyright (C) 2004 by Brent Kelly                                     *
 *   hornedgod@hotmail.com                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kledwindow.h"
#include "kwin.h"
#include <qlabel.h>
#include "kledwindow.xpm"

KLedwindow::KLedwindow()
 : KMainWindow()
{
    this->setFixedSize( 330, 180 );
	
    /* set up the little window icon (top left) */
    QPixmap winIcon = QPixmap( kledwindow_xpm );
    KWin::setIcons(this->winId(), winIcon, winIcon);
    
   this->setCaption( QString("Traffic Status") );

    
    /* send a receive current packet count labels */
    this->m_rxTextLabel = new QLabel( this, "receivelabel", 0);
    this->m_rxTextLabel->move( QPoint(10, 80));
    this->m_rxTextLabel->setFixedSize( 80, 15);
    this->m_rxTextLabel->setText(QString("Received:"));    
    
    this->m_txTextLabel = new QLabel(this, "sendlabel", 0);
    this->m_txTextLabel->move( QPoint(10, 40));
    this->m_txTextLabel->setFixedSize( 80, 15);
    this->m_txTextLabel->setText(QString("Sent:"));
    
    /* send and receive current packet count amounts*/
    this->m_rxAmountLabel = new QLabel( this, "receiveamount", 0);
    this->m_rxAmountLabel->move( QPoint(100, 80));
    this->m_rxAmountLabel->setFixedSize( 200, 15);
    this->m_rxAmountLabel->setAlignment( AlignRight );
    
    this->m_txAmountLabel = new QLabel(this, "sendamount", 0);
    this->m_txAmountLabel->move( QPoint(100, 40));
    this->m_txAmountLabel->setFixedSize( 200, 15);
    this->m_txAmountLabel->setAlignment( AlignRight );
    
    this->m_btnClose = new QPushButton( this, "close" );
    this->m_btnClose->setText( QString( "Close" ) );
    this->m_btnClose->move( QPoint( 220, 140 ) );
    this->m_btnClose->show();
    
    this->connect( this->m_btnClose, SIGNAL(clicked()), this, SLOT(slot_CloseClicked()) );
}

void KLedwindow::updateStatus(long tx, long rx) {
    char updates[255];
    
    sprintf(updates, "%d packets", rx);
    this->m_rxAmountLabel->setText(QString(updates));
    
    sprintf(updates, "%d packets", tx);
    this->m_txAmountLabel->setText(QString(updates));
    
}

/* dont let this window close entire app
   (which it does for some reason) */
bool KLedwindow::queryClose() {
    this->hide();
    return(false);
}

void KLedwindow::slot_CloseClicked() {
    this->hide();
}

KLedwindow::~KLedwindow()
{
    delete m_rxTextLabel;
    delete m_txTextLabel;
    delete m_rxAmountLabel;
    delete m_txAmountLabel;
    delete m_btnClose;
}


